package xyz.lychee.lagfixer.libs.adventure.audience;

import java.util.Optional;
import java.util.function.Consumer;
import java.util.function.Predicate;
import java.util.function.Supplier;
import xyz.lychee.lagfixer.libs.adventure.chat.ChatType;
import xyz.lychee.lagfixer.libs.adventure.chat.SignedMessage;
import xyz.lychee.lagfixer.libs.adventure.identity.Identified;
import xyz.lychee.lagfixer.libs.adventure.identity.Identity;
import xyz.lychee.lagfixer.libs.adventure.inventory.Book;
import xyz.lychee.lagfixer.libs.adventure.pointer.Pointer;
import xyz.lychee.lagfixer.libs.adventure.resource.ResourcePackInfoLike;
import xyz.lychee.lagfixer.libs.adventure.resource.ResourcePackRequest;
import xyz.lychee.lagfixer.libs.adventure.text.Component;
import xyz.lychee.lagfixer.libs.adventure.text.ComponentLike;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.UnknownNullability;

final class EmptyAudience implements Audience {
   static final EmptyAudience INSTANCE = new EmptyAudience();

   public <T> @NotNull Optional<T> get(final @NotNull Pointer<T> pointer) {
      return Optional.empty();
   }

   @Contract("_, null -> null; _, !null -> !null")
   public <T> @Nullable T getOrDefault(final @NotNull Pointer<T> pointer, final @Nullable T defaultValue) {
      return defaultValue;
   }

   public <T> @UnknownNullability T getOrDefaultFrom(final @NotNull Pointer<T> pointer, final @NotNull Supplier<? extends T> defaultValue) {
      return defaultValue.get();
   }

   public @NotNull Audience filterAudience(final @NotNull Predicate<? super Audience> filter) {
      return this;
   }

   public void forEachAudience(final @NotNull Consumer<? super Audience> action) {
   }

   public void sendMessage(final @NotNull ComponentLike message) {
   }

   public void sendMessage(final @NotNull Component message) {
   }

   /** @deprecated */
   @Deprecated
   public void sendMessage(final @NotNull Identified source, final @NotNull Component message, final @NotNull MessageType type) {
   }

   /** @deprecated */
   @Deprecated
   public void sendMessage(final @NotNull Identity source, final @NotNull Component message, final @NotNull MessageType type) {
   }

   public void sendMessage(final @NotNull Component message, final ChatType.@NotNull Bound boundChatType) {
   }

   public void sendMessage(final @NotNull SignedMessage signedMessage, final ChatType.@NotNull Bound boundChatType) {
   }

   public void deleteMessage(final SignedMessage.@NotNull Signature signature) {
   }

   public void sendActionBar(final @NotNull ComponentLike message) {
   }

   public void sendPlayerListHeader(final @NotNull ComponentLike header) {
   }

   public void sendPlayerListFooter(final @NotNull ComponentLike footer) {
   }

   public void sendPlayerListHeaderAndFooter(final @NotNull ComponentLike header, final @NotNull ComponentLike footer) {
   }

   public void openBook(final Book.@NotNull Builder book) {
   }

   public void sendResourcePacks(final @NotNull ResourcePackInfoLike request, final @NotNull ResourcePackInfoLike... others) {
   }

   public void removeResourcePacks(final @NotNull ResourcePackRequest request) {
   }

   public void removeResourcePacks(final @NotNull ResourcePackInfoLike request, final @NotNull ResourcePackInfoLike... others) {
   }

   public boolean equals(final Object that) {
      return this == that;
   }

   public int hashCode() {
      return 0;
   }

   public String toString() {
      return "EmptyAudience";
   }
}
